"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Highlighter = void 0;
var tslib_1 = require("tslib");
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var client_1 = tslib_1.__importDefault(require("react-dom/client"));
var index_1 = tslib_1.__importDefault(require("html-react-parser/lib/index"));
var serialize_1 = require("../../libs/serialize");
var react_2 = require("react");
var uid_1 = require("../../libs/uid");
var wrapperElements_1 = require("../../libs/wrapperElements");
var DeafultPopover_1 = tslib_1.__importDefault(require("../DeafultPopover"));
var UseSelection_1 = require("../../hooks/UseSelection");
var constants_1 = require("../../constants/constants");
var dom_1 = require("../../libs/dom");
var Highlighter = function (_a) {
    var htmlString = _a.htmlString, onClickHighlight = _a.onClickHighlight, disablePopover = _a.disablePopover, maxSelectionLength = _a.maxSelectionLength, minSelectionLength = _a.minSelectionLength, className = _a.className, PopoverChildren = _a.PopoverChildren, PopoverClassName = _a.PopoverClassName, selectionWrapperClassName = _a.selectionWrapperClassName, onClick = _a.onClick;
    var _b = (0, UseSelection_1.useSelections)(), selections = _b.selections, addSelection = _b.addSelection, removeSelection = _b.removeSelection, updateSelection = _b.updateSelection;
    var popoverRoots = (0, react_1.useRef)({});
    var content = (0, react_2.useMemo)(function () { return (0, index_1.default)(htmlString); }, [htmlString]);
    var getWrapper = (0, react_2.useCallback)(function (selection) {
        var span = (0, wrapperElements_1.getSpanElement)({ className: selection.className || constants_1.defaultSelectionWrapperClassName });
        if (!disablePopover) {
            var popover_1 = (0, wrapperElements_1.getPopoverElement)({ className: PopoverClassName });
            if (!PopoverClassName) {
                span.addEventListener('mouseover', function () {
                    popover_1.style.visibility = 'visible';
                    popover_1.style.opacity = '1';
                });
                span.addEventListener('mouseout', function () {
                    popover_1.style.visibility = 'hidden';
                    popover_1.style.opacity = '0';
                });
            }
            popover_1.id = "pop-".concat(selection.id);
            span.appendChild(popover_1);
            var root = client_1.default.createRoot(popover_1);
            popoverRoots.current[selection.id] = root;
        }
        if (onClickHighlight) {
            span.onclick = function (e) { return onClickHighlight(selection, e); };
        }
        span.id = selection.id;
        return span;
    }, [PopoverClassName, disablePopover, onClickHighlight]);
    var handleMouseUp = function () {
        var selection = window.getSelection();
        if (!selection)
            return;
        if (!minSelectionLength) {
            minSelectionLength = constants_1.defaultMinSelectionLength;
        }
        if (minSelectionLength && selection.toString().length < minSelectionLength)
            return;
        if (maxSelectionLength && selection.toString().length > maxSelectionLength)
            return;
        var range = selection.getRangeAt(0);
        if (!(0, dom_1.isHighlightable)(range))
            return;
        var newSelection = {
            meta: (0, serialize_1.serializeRange)(range),
            text: range.toString(),
            id: "selection-".concat((0, uid_1.generateId)()),
            className: selectionWrapperClassName || constants_1.defaultSelectionWrapperClassName,
        };
        addSelection(newSelection);
    };
    (0, react_2.useEffect)(function () {
        var currentRefs = popoverRoots.current;
        if (selections && selections.length) {
            selections.forEach(function (item) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
                var range;
                var _a, _b;
                return tslib_1.__generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, (0, serialize_1.deserializeRange)(item.meta)];
                        case 1:
                            range = _c.sent();
                            if (range) {
                                (0, dom_1.addHighlight)(range, getWrapper(item));
                            }
                            if (PopoverChildren) {
                                (_a = popoverRoots.current[item.id]) === null || _a === void 0 ? void 0 : _a.render((0, jsx_runtime_1.jsx)(PopoverChildren, { selection: item, removeSelection: removeSelection, updateSelection: updateSelection }));
                            }
                            else {
                                (_b = popoverRoots.current[item.id]) === null || _b === void 0 ? void 0 : _b.render((0, jsx_runtime_1.jsx)(DeafultPopover_1.default, { removeSelection: removeSelection, selection: item, updateSelection: updateSelection }));
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
        }
        return function () {
            Object.keys(currentRefs).forEach(function (item) { return function () { var _a; return (_a = currentRefs[item]) === null || _a === void 0 ? void 0 : _a.unmount(); }; });
        };
    }, [selections, getWrapper, PopoverChildren, removeSelection, updateSelection]);
    return ((0, jsx_runtime_1.jsx)("div", { onClick: onClick, onMouseUp: handleMouseUp, className: className, children: content }));
};
exports.Highlighter = Highlighter;
